
freeslot("MT_PUTTSTAR", "MT_GOLFSTAR", "MT_GOLFARROW", "MT_GOLFFLAG", "MT_GOLFMARKER", "MT_YOUARE",
		 "S_PLAY_FAUXDASH",
		 "sfx_frev", "sfx_phit",
		 "tol_golf")

states[S_PLAY_FAUXDASH] = {SPR_PLAY, SPR2_SPIND, 4, nil, 0, 0, S_PLAY_FAUXDASH}

sfxinfo[sfx_frev].caption = "Revving"
sfxinfo[sfx_kc5d].caption = "Position saved"
sfxinfo[sfx_s25a].caption = "Bouncing"
sfxinfo[sfx_phit].caption = "Ball hit"
sfxinfo[sfx_cdfm51].caption = "Putt canceled"

G_AddGametype({
    name = "Golf",
    identifier = "golf",
    typeoflevel = TOL_GOLF,
    rules = GTR_SPECTATORS|GTR_FRIENDLY|GTR_SPAWNENEMIES,
    rankingtype = GT_COOP,
	intermissiontype = int_match,
    headercolor = 96,
    description = 'Compete with your friends in a variety of zany golf courses! The one with the least putts by the end of a course wins!'
})

//Spawn and thinker for checkpoint flag
addHook("MobjSpawn", function(flag)
	flag.holup = 16
	local dust = P_SpawnMobjFromMobj(flag, -2*cos(flag.angle), -2*sin(flag.angle), 8*FRACUNIT, MT_SPINDUST)
	dust.scale = 2*FRACUNIT
	dust.destscale = 0
	dust.scalespeed = FRACUNIT/6
end, MT_GOLFFLAG)

addHook("MobjThinker", function(youare)
	//Up and down movement
	local fluctuate = {-2,-1,0,1,2,1,0,-1}
	if (leveltime%2 == 0) then 
		local alternator = fluctuate[((leveltime%16)/2) + 1]
		youare.z = $+(alternator*FRACUNIT) 
	end
	//Only show your own YOU ARE HERE icon
	if youare.owner ~= displayplayer then
		youare.flags2 = $ | MF2_DONTDRAW
	else
		youare.flags2 = $ & ~MF2_DONTDRAW
	end
	//Making sure the YOU ARE HERE icon is only displayed if you're a spectator
	if youare.owner.mo or not youare.owner.realmo then
		P_KillMobj(youare)
	end
end, MT_YOUARE)

addHook("MobjThinker", function(flag)
	if flag.holup then 
		flag.holup = $-1
		if not flag.holup then 
			flag.flags = $ & ~MF_NOGRAVITY --flag.flags, tee hee
		end
	end
	if (not (flag.flags & MF_NOGRAVITY)) and flag.z/FRACUNIT <= flag.endZ/FRACUNIT then
		flag.flags = $ | MF_NOGRAVITY
		flag.momz = 0
	end
	if not flag.owner.valid then
		P_KillMobj(flag)
	end
end, MT_GOLFFLAG)

//Spawn and thinker for star
addHook("MobjSpawn", function(star)
	star.momz = P_RandomRange(4, 5)*FRACUNIT/2
end, MT_GOLFSTAR)

addHook("MobjThinker", function(star)
	if leveltime%4 == 0 then star.colorized = true else star.colorized = false end
	if star.scale == FRACUNIT/3 then
		star.destscale = 0
		star.resize = true
	elseif not star.resize then
		star.destscale = FRACUNIT/3
	end
end, MT_GOLFSTAR)

//Putt star thinker (it's different I swear)
addHook("MobjThinker", function(star)
	star.rollangle = $ + ANG15
	if star.ignore then return end
	star.chaseangle = $ + ANG10/2
	local dist = 30
	P_TeleportMove(star, star.target.x + dist*cos(star.chaseangle), star.target.y + dist*sin(star.chaseangle), star.target.z + star.target.height/2)
end, MT_PUTTSTAR)